#include <iostream>
#include <cmath>
using namespace std;
int main()
{
	int m,n,c,r,n1;
	n1=20000001;
	int mod=998244353;
	long long x=0;
	int b[100001];
	int a[500001];
	cin>>n>>m;
	for(int i=1;i<=m;i++)
	{
		cin>>b[i];
	}
	cin>>c;
	for(int i=1;i<=n;i++)
	{
		a[i]=i;
	}
	for(int i=0;i<=n-m;i++)
	{
	    for(int j=1;j<=m;j++)
	    {
	        a[i+b[j]]=a[i+j];
	    }
	}
	for(int i=1;i<=n;i++)
	{
		x+=pow(c,i)*a[i];
	}
	r=x%mod;
	cout<<r<<endl;
	return 0;
}